VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Untitled"
   ClientHeight    =   11100
   ClientLeft      =   1140
   ClientTop       =   855
   ClientWidth     =   15240
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   740
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   1016
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
   WindowState     =   2  'Maximized
   Begin VB.PictureBox pic1024 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   15360
      Left            =   10560
      ScaleHeight     =   1024
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   1024
      TabIndex        =   8
      Top             =   6600
      Visible         =   0   'False
      Width           =   15360
   End
   Begin VB.PictureBox piczoomtileset 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   2400
      Left            =   10560
      ScaleHeight     =   160
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   304
      TabIndex        =   7
      Top             =   2160
      Visible         =   0   'False
      Width           =   4560
   End
   Begin VB.PictureBox pictileset 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   2400
      Left            =   10560
      ScaleHeight     =   160
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   304
      TabIndex        =   6
      Top             =   1080
      Visible         =   0   'False
      Width           =   4560
   End
   Begin VB.PictureBox picclipboard 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   240
      Left            =   10920
      ScaleHeight     =   16
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   16
      TabIndex        =   5
      Top             =   4680
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.PictureBox picempty 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   240
      Left            =   10560
      ScaleHeight     =   16
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   16
      TabIndex        =   4
      Top             =   4680
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.PictureBox piclevel 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Serif"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   1455
      Left            =   10560
      ScaleHeight     =   97
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   73
      TabIndex        =   3
      Top             =   5040
      Visible         =   0   'False
      Width           =   1095
   End
   Begin VB.VScrollBar vScr 
      Height          =   7575
      Left            =   10080
      TabIndex        =   2
      Top             =   0
      Width           =   255
   End
   Begin VB.HScrollBar hScr 
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   7560
      Width           =   10095
   End
   Begin VB.PictureBox picpreview 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   7575
      Left            =   0
      ScaleHeight     =   505
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   673
      TabIndex        =   0
      Top             =   0
      Width           =   10095
      Begin VB.Shape shpdraw 
         BorderColor     =   &H00FFFFFF&
         BorderStyle     =   3  'Dot
         Height          =   135
         Left            =   600
         Top             =   840
         Visible         =   0   'False
         Width           =   135
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim BMPFileHeader As BITMAPFILEHEADER   'Holds the file header
Dim BMPInfoHeader As BITMAPINFOHEADER   'Holds the info header
Dim BMPRGBQuad() As RGBQUAD             'Holds the colour table
Dim BMPData() As Byte                   'Holds the pixel data

'current tile selected left/right
Public tilesetleft As Integer
Public tilesetright As Integer

'size of the tiles selected
Public multTileLeftx As Integer
Public multTileLefty As Integer
Public multTileRightx As Integer
Public multTileRighty As Integer

'pressing ctrl ?
Dim usingctrl As Boolean

'has map been changed ?
Public mapchanged As Boolean
Public activeFile As String

'using the default tileset ? so no bitmap of tileset is present
Public usingDefaultTileset As Boolean

'holds the entire map
Dim tile(1023, 1023) As Integer

'different paste types
Enum enumPasteType
    p_trans
    p_under
    p_normal
End Enum
Public pastetype As enumPasteType

'grid on/off
Public usinggrid As Boolean

'grid lines hidden under existing tiles on/off
'NOT USED YET
Public usinghidegrid As Boolean

'tilenr display on/off
Public usingtilenr As Boolean
'fill within borders of the screen on/off
Public fillinscreen As Boolean
'fill shapes on/off
Public fillshapes As Boolean

'is the tileset already loaded?
Public tilesetloaded As Boolean

'used for correct updating of the scrollbars (so they dont update both)
Dim dontUpdateOnValueChange As Boolean

'holds the current id of the map from the map
Public id As Integer

'holds the top and left of the radar
Public radar_left As Integer
Public radar_top As Integer

'is used to determine if we are using the dropper tool by holding ctrl
Dim tempdropping As Boolean
'holds the tool previously used before the dropper tool was selected by ctrl
Dim toolbeforetempdropping As toolenum

'the from position where the selection began
Dim fromtilex As Integer
Dim fromtiley As Integer

Dim origX As Single
Dim origY As Single

'used to store the results of CheckCtrlShift
Dim tempx As Single
Dim tempy As Single

Dim bookmark(10) As Long

'these are the tools
Public magnifier As New magnifier
Public sel As New Selection
Public clip As New ClipB
Public pencil As New pencil
Public tline As New Line
Public dropper As New dropper
Public bucket As New bucket
Public hand As New hand
Public undoredo As New UndoRedoStack
Public SPline As New SPline
Public airbr As New AirBrush
Public walltiles As New walltiles

Private Sub Form_Activate()
    'draw the tileset of the current map on the general form
    BitBlt frmGeneral.pictileset.hdc, 0, 0, pictileset.Width, pictileset.Height, pictileset.hdc, 0, 0, vbSrcCopy
    frmGeneral.pictileset.refresh
    
    'make the activemap = this
    frmGeneral.activemap = id
    
    'now the activemap is set,
    'update the layout to match the attributes of the map
    frmGeneral.UpdateToolbarButtons
    
    'set the tileset left and right
    Call frmGeneral.SetLeftSelection(tilesetleft, 1, 1)
    Call frmGeneral.SetRightSelection(tilesetright, 1, 1)
    
    'select the this map under the menu items
    frmGeneral.UpdateMenuMaps
    
    'update the level map
    UpdateLevel
End Sub

Private Sub Form_Initialize()
'Initializes every tool used by the map
    Call undoredo.setParent(Me)
    Call sel.setParent(Me)
    Call magnifier.setParent(Me)
    Call clip.setParent(Me)
    Call pencil.setParent(Me)
    Call tline.setParent(Me)
    Call dropper.setParent(Me)
    Call bucket.setParent(Me)
    Call hand.setParent(Me)
    Call SPline.setParent(Me)
    Call airbr.setParent(Me)
    Call walltiles.setParent(Me)
End Sub

Private Sub Form_Load()
'Loads the default settings for a map
    
    'use grid, no tile numbers, fill in shapes and fill in screen
    usinggrid = True
    usingtilenr = False
    fillshapes = True
    fillinscreen = True
    
    usinghidegrid = True
    
    'normal pasting
    pastetype = p_normal
    'default tileset selections
    tilesetleft = 1
    tilesetright = 2

    Hook Me.hWnd
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
'Close the map
    If mapchanged = True Then
        'the map has been changed, ask if the user wants to save it
        Dim retval As Integer
        retval = MsgBox(Me.Caption & " - " & "Not all changes have been saved, do you want to proceed?", vbQuestion + vbYesNo)
        If retval = vbNo Then
            'don't close
            Cancel = True
            Exit Sub
        End If
    End If
    
    'ask the general form to destroy the map
    Call frmGeneral.DestroyMap(id)
    
    UnHook Me.hWnd
End Sub

Private Sub Form_Resize()
'Updates the controls when resizing
    If frmGeneral.WindowState <> vbMinimized And Me.WindowState <> vbMinimized Then
        'when the form is resized, the scrollbars and preview need to be
        'resized too
        On Error Resume Next
        'update scroll barrs
        hScr.Top = Me.ScaleHeight - hScr.Height
        hScr.Width = Me.ScaleWidth - vscr.Width
        vscr.Left = Me.ScaleWidth - vscr.Width
        vscr.Height = Me.ScaleHeight - hScr.Height
        
        'update preview picture
        picpreview.Width = Me.ScaleWidth - vscr.Width
        picpreview.Height = Me.ScaleHeight - hScr.Height
        
        'update level picture according to preview picture
        piclevel.Width = picpreview.Width
        piclevel.Height = picpreview.Height
        
        'because the form is resized, the preview can contain more data
        'from the level that was previously not loaded, so load it now
        UpdateLevel
    End If
End Sub

Private Sub hScr_Change()
'Updates the horizontal scrollbar
    
    If Not dontUpdateOnValueChange Then
        UpdateLevel
    End If
    
    'put focus back on picpreview
    On Error Resume Next
    picpreview.SetFocus
End Sub






Private Sub vscr_Change()
'Updates the vertical scrollbar

    If Not dontUpdateOnValueChange Then
        UpdateLevel
    End If
    
    'put focus back on picpreview
    On Error Resume Next
    picpreview.SetFocus
End Sub

Private Sub picpreview_KeyDown(KeyCode As Integer, Shift As Integer)
'When a key is pressed, use the shortcuts
    Call UseShortcutTool(True, KeyCode, Shift)
End Sub

Private Sub picpreview_KeyUp(KeyCode As Integer, Shift As Integer)
'When a key is pressed, use the shortcuts
    Call UseShortcutTool(False, KeyCode, Shift)
End Sub

Private Sub picpreview_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'Apply the current tool the map
    'we have mousedown
    SharedVar.MouseDown = True
    
    Dim curtilex As Integer
    Dim curtiley As Integer

Select Case curtool
    Case t_pencil
        x = x - 3
        y = y + 6
    Case T_Eraser
        x = x - 7
        y = y + 5
    Case t_bucket
        x = x - 6
        y = y + 6
End Select

    origX = x
    origY = y

    'calculate the tiles from the clicked pixel
    curtilex = (Int(((hScr.value + x)) / (TileW * magnifier.Zoom)))
    curtiley = (Int(((vscr.value + y)) / (TileH * magnifier.Zoom)))
    
    'updates the fromtilex and fromtiley
    If Not SharedVar.splineInProgress Then
        fromtilex = curtilex
        fromtiley = curtiley
    End If
    

    
Select Case curtool
    Case T_selection
        If Button Then frmGeneral.lblToA.Visible = True
        Call sel.MouseDown(Button, x, y)
        
    Case T_magnifier
        Call magnifier.MouseDown(Button, x, y)
        
    Case T_hand
        Call hand.MouseDown(x, y)
        
    Case t_pencil
        Call pencil.MouseDown(Button, x, y)
    Case T_Eraser
        Call pencil.MouseDown(Button, x, y)
        
    Case t_spline
        If Button Then frmGeneral.lblToA.Visible = True
        'make adjustments to make it perfectly diagonal
        'the results are stored in tempx and tempy
        Call CheckShiftCtrl(Shift, curtilex, curtiley)
        
        'now use the enhanced coordinates (calculate them back to pixels)
        'in the mousedown
        Call SPline.MouseDown(Button, _
                              (tempx * TileW * magnifier.Zoom) - hScr.value, _
                              (tempy * TileH * magnifier.Zoom) - vscr.value, val(frmGeneral.txtStep))
        
        'update the from coordinates
        If SharedVar.splineInProgress Then
            fromtilex = tempx
            fromtiley = tempy
        End If
    
    Case t_dropper
        Call dropper.MouseDown(Button, x, y)
    
    Case t_bucket
        Call bucket.MouseDown(Button, x, y)
        
    Case T_line, T_rectangle, T_ellipse, T_filledellipse, T_filledrectangle
        If Button Then frmGeneral.lblToA.Visible = True
        Call tline.MouseDown(Button, x, y)
    
    Case T_airbrush
        Call airbr.MouseDown(Button, x, y)
End Select

If curtool <> t_spline Or SharedVar.splineInProgress = True Then
    frmGeneral.lblFrom = "X= " & fromtilex & " - Y= " & fromtiley
    frmGeneral.lblFrom.Visible = True
    frmGeneral.lblFromA.Visible = True
Else
    frmGeneral.lblToA.Visible = False
    frmGeneral.lblFromA.Visible = False
    frmGeneral.lblTo.Visible = False
    frmGeneral.lblFrom.Visible = False
End If


End Sub

Private Sub picpreview_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
'Apply the tools when hovering over the preview
    Dim curtilex As Integer
    Dim curtiley As Integer

Select Case curtool
    Case t_pencil
        x = x - 3
        y = y + 6
    Case T_Eraser
        x = x - 7
        y = y + 5
End Select


    curtilex = (Int(((hScr.value + x)) / (TileW * magnifier.Zoom)))
    curtiley = (Int(((vscr.value + y)) / (TileH * magnifier.Zoom)))
    'update the position currently hovering over in tile coordinates
    If frmGeneral.lblposition.Caption <> "X= " & curtilex & " - Y= " & curtiley & " (" & Chr(65 + Int(curtilex / Int(1024 / 20))) & 1 + Int(curtiley / Int(1024 / 20)) & ")" Then
        'only update label when it has actually changed (to prevent flickering)
        frmGeneral.lblposition.Caption = "X= " & curtilex & " - Y= " & curtiley & " (" & Chr(65 + Int(curtilex / Int(1024 / 20))) & 1 + Int(curtiley / Int(1024 / 20)) & ")"
    End If

Select Case curtool
    Case T_selection
        If Button Then
            'calculate the distance covered since mousedown
            frmGeneral.lblTo.Visible = True
            If frmGeneral.lblTo.Caption <> "X= " & curtilex - fromtilex & " - Y= " & curtiley - fromtiley Then
                frmGeneral.lblToA.Visible = True
                frmGeneral.lblTo.Caption = "X= " & curtilex - fromtilex & " - Y= " & curtiley - fromtiley
            End If
        End If
        
        'DISABLED - causes bug when moving around with shift pressed
        'selection is also a rectangle so when pressing shift
        'make the selection rectangle
        'Call CheckShiftCtrl(Shift, curtilex, curtiley)
        tempx = curtilex
        tempy = curtiley
        '''''''''
        
        'now call the mousemove with possible enhanced coordinates
        Call sel.MouseMove((tempx * TileW * magnifier.Zoom) - hScr.value, _
                           (tempy * TileH * magnifier.Zoom) - vscr.value)
    
    Case T_magnifier
        Call magnifier.MouseMove
        
    Case T_hand
        Call hand.MouseMove(x, y)
        
    Case t_pencil
        Call pencil.MouseMove(Button, x, y)
    Case T_Eraser
        Call pencil.MouseMove(Button, x, y)
        
    Case t_spline
        If SharedVar.splineInProgress Then
            'calculate the distance
            frmGeneral.lblTo.Visible = True
            If frmGeneral.lblTo.Caption <> "X= " & curtilex - fromtilex & " - Y= " & curtiley - fromtiley Then
                frmGeneral.lblToA.Visible = True
                frmGeneral.lblTo.Caption = "X= " & curtilex - fromtilex & " - Y= " & curtiley - fromtiley
            End If
        Else
            'hide the from and to when not using the tool anymore
            frmGeneral.lblToA.Visible = False
            frmGeneral.lblFromA.Visible = False
        End If
                
        'calculate enhanced coordinates if we press shift or ctrl
        Call CheckShiftCtrl(Shift, curtilex, curtiley)

        'use the enhanced coordinates
        Call SPline.MouseMove(Button, _
                              (tempx * TileW * magnifier.Zoom) - hScr.value, _
                              (tempy * TileH * magnifier.Zoom) - vscr.value, val(frmGeneral.txtStep))

    Case t_dropper
        Call dropper.MouseMove(Button, x, y)

    Case t_bucket
        Call bucket.MouseMove

    Case T_line, T_rectangle, T_ellipse, T_filledellipse, T_filledrectangle
        If Button Then
            'show distance
            frmGeneral.lblTo.Visible = True
            If frmGeneral.lblTo.Caption <> "X= " & curtilex - fromtilex & " - Y= " & curtiley - fromtiley Then
                frmGeneral.lblToA.Visible = True
                frmGeneral.lblTo.Caption = "X= " & curtilex - fromtilex & " - Y= " & curtiley - fromtiley
            End If
        End If
        'calculate enhanced coordinates
        Call CheckShiftCtrl(Shift, curtilex, curtiley)

        'use those coordinates
        Call tline.MouseMove(Button, _
                             (tempx * TileW * magnifier.Zoom) - hScr.value, _
                             (tempy * TileH * magnifier.Zoom) - vscr.value, _
                             origX, origY, val(frmGeneral.txtStep), usingctrl)
    Case T_airbrush
        Call airbr.MouseMove(Button, x, y)
    End Select
    
    
    'Move map while dragging if needed
    If Button And Not (curtool = T_airbrush Or curtool = T_hand Or curtool = T_selection) Then
        Call DragMap(x, y, Shift)
    End If
    
    
End Sub

Private Sub picpreview_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
'do tool events when mouseup
    
    'no more mouse down
    SharedVar.MouseDown = False
    
    Dim curtilex As Integer
    Dim curtiley As Integer
    'calculate tile coordinates
    curtilex = (Int(((hScr.value + x)) / (TileW * magnifier.Zoom)))
    curtiley = (Int(((vscr.value + y)) / (TileH * magnifier.Zoom)))

    'when using anything else than spline, hide the
    'to and from afterwards
    If curtool <> t_spline Then
            frmGeneral.lblToA.Visible = False
            frmGeneral.lblFromA.Visible = False
            frmGeneral.lblTo.Visible = False
            frmGeneral.lblFrom.Visible = False
    End If

    Select Case curtool
        Case T_selection
            Call sel.MouseUp
        
        Case T_magnifier
            Call magnifier.MouseUp
        
        Case T_hand
            Call hand.MouseUp
    
        Case t_pencil, T_Eraser
            Call pencil.MouseUp
            
        Case t_spline
            Call SPline.MouseUp(Button, x, y)
    
        Case t_bucket
            Call bucket.MouseUp
    
        Case T_line, T_rectangle, T_ellipse, T_filledrectangle, T_filledellipse
            'calculate enhanced coordinates
            Call CheckShiftCtrl(Shift, curtilex, curtiley)
            'use mouseup with those coordinates
            Call tline.MouseUp(Button, _
                               (tempx * TileW * magnifier.Zoom) - hScr.value, _
                               (tempy * TileH * magnifier.Zoom) - vscr.value, _
                               origX, origY, val(frmGeneral.txtStep), usingctrl)
        Case T_airbrush
            Call airbr.MouseUp
    End Select
    

End Sub

Sub ImportTileset(filename As String)
'Imports a tileset into the current map
    Dim f As Integer
    f = FreeFile
    
    Dim bm As Integer
    Dim size As Long
    
    Dim b() As Byte
    
    Dim tmpfileh As BITMAPFILEHEADER
    Dim tmpinfoh As BITMAPINFOHEADER
    
    Open filename For Binary As #f
        ReDim b(1)
        Get #f, , b
        
        If Chr(b(0)) & Chr(b(1)) <> "BM" Then
            'if there is no BM it means that we have either a
            'corrupt lvl or bmp file, or we have a lvl file
            'that uses the default tileset
        Else
            'rewind to beginning
            Seek #f, 1
            Get #f, , tmpfileh
            Get #f, , tmpinfoh
            'check if its lower than 8 bit
            'and check for width=304 and height=160
            'if it's not, we have an invalid bmp or lvl
            'to import
            If tmpinfoh.biBitCount < 8 Or tmpinfoh.biHeight <> 160 Or tmpinfoh.biWidth <> 304 Then
                MsgBox "Tilesets are required to be 304x160 pixels, with 8-bit or 24-bit color depth!"
                Close #f
                Exit Sub
            End If
            
            
            'ok valid tileset, importing
            BMPFileHeader = tmpfileh
            BMPInfoHeader = tmpinfoh
            
            If tmpinfoh.biBitCount = 8 Then
                ReDim BMPRGBQuad(255)
                Get #f, , BMPRGBQuad
            End If
            
            'resize the data to fit the entire bmpdata
            'this data will only be used to save the map again
            ReDim BMPData(BMPInfoHeader.biSizeImage)
            
            Get #f, , BMPData
            'this is the end of the tileset.
            'ok, we have the bmp data
        End If
    Close #f
    
    'load the tileset from the lvl into the tileset and zoomtileset
    Call InitTileset(filename)
    
    'the map has changed
    mapchanged = True
    
    'not using default tileset anymore
    usingDefaultTileset = False
    
    'update the menu's
    frmGeneral.mnudiscardtileset.Enabled = True
    frmGeneral.mnuExportTileset.Enabled = True
    
    'update the level to sync with the new tileset
    UpdateLevel
End Sub

Sub InitTileset(Optional path As String)
'Load the tileset from the lvl into the tileset
    If path = "" Then
        'no path is given, load the default tileset, if it exists
        If Dir(App.path & "\default.bmp") = "default.bmp" Then
            'load it
            tilesetloaded = True
            pictileset.Picture = LoadPicture(App.path & "\default.bmp")
        Else
            'default tileset is not present, ask to import
            tilesetloaded = False
            MsgBox "Default tileset not found, please select a tileset to use." & vbNewLine _
                & "To avoid seeing this error again, place a tileset file named 'Default.bmp' in the same folder as DCME.", vbCritical
            Call frmGeneral.ImportTileset
            Exit Sub
        End If
    Else
        'load the picture from the path
        pictileset.Picture = LoadPicture(path)
        tilesetloaded = True
    End If
        
    'create the correct size for the tileset
    pictileset.AutoSize = True
    pictileset.AutoSize = False
    pictileset.Height = pictileset.Height + frmGeneral.picextratiles.Height
    
    pictileset.refresh
    
    'create the correct size for the zoomed tileset
    piczoomtileset.Width = pictileset.Width * magnifier.Zoom
    piczoomtileset.Height = pictileset.Height * magnifier.Zoom
    
    'bitblt the extratiles on the tileset, so they will be zoomed along with the others
    BitBlt pictileset.hdc, 0, pictileset.Height - frmGeneral.picextratiles.Height, pictileset.Width, frmGeneral.picextratiles.Height, frmGeneral.picextratiles.hdc, 0, 0, vbSrcCopy
    
    pictileset.refresh
    
    'draw the zoomed tiles onto the zoomtileset
    With Me
        SetStretchBltMode .piczoomtileset.hdc, HALFTONE
        StretchBlt .piczoomtileset.hdc, 0, 0, .piczoomtileset.Width, .piczoomtileset.Height, .pictileset.hdc, 0, 0, .pictileset.Width, .pictileset.Height, vbSrcCopy
        .piczoomtileset.refresh
    End With
    
    'copy the tileset data on the visible tileset
    BitBlt frmGeneral.pictileset.hdc, 0, 0, pictileset.Width, pictileset.Height, pictileset.hdc, 0, 0, vbSrcCopy
    frmGeneral.pictileset.refresh
    frmGeneral.UpdatePreview
    
    Call frmGeneral.UpdateToolbarButtons
End Sub


Sub ExportTileset(path As String)
'Exports the current tileset
    If usingDefaultTileset Then
        'there is no tileset
        Exit Sub
    End If
    
    'if the user selected a file that already exists, delete the file
    If Dir$(path) <> "" Then
        Kill path
    End If
    
    Dim f As Integer
    f = FreeFile
    Open path For Binary As #f
        'open the file and write all bmp data stored
        Put #f, , BMPFileHeader
        Put #f, , BMPInfoHeader
        
        If BMPInfoHeader.biBitCount = 8 Then
            Put #f, , BMPRGBQuad
        End If
        
        Put #f, , BMPData
        
    Close #f
End Sub

Sub DiscardTileset()
'Discard the current tileset
    usingDefaultTileset = True
    
    'load the default tileset
    InitTileset ("")
    
    'map has changed
    mapchanged = True
    
    'update level to sync with default tileset
    UpdateLevel
End Sub

Sub setTile(tileX As Integer, tileY As Integer, value As Integer, undoch As Changes, Optional appendundo = True)
'Sets the tile, and if required update the given undo changes stack
    If Not tile(tileX, tileY) = value Then
        'if the given value is different, change its value and update
        'the given undoch if appendundo = true
        If appendundo Then
            Call undoch.AddChange(tileX, tileY, tile(tileX, tileY))
        End If
        tile(tileX, tileY) = value
    End If
End Sub

Function getTile(tileX As Integer, tileY As Integer)
'Retrieves the value of a tile at the given coordinates
    getTile = tile(tileX, tileY)
End Function

Sub EraseTiles()
'erases the entire tile array
    Erase tile
End Sub

Sub NewMap()
'Creates a new map with default tileset
    usingDefaultTileset = True
    
    'use default tileset
    Call InitTileset("")
    
    dontUpdateOnValueChange = True
    UpdateScrollBars
    'set the preview in the center of the map
    hScr.value = Int(Int(hScr.Max / 2) / TileW) * TileW
    vscr.value = Int(Int(vscr.Max / 2) / TileH) * TileH
    dontUpdateOnValueChange = False
    
    'the map isn't changed as it has just been created
    mapchanged = False
    
    'the map hasn't been saved yet
    activeFile = ""
    
    Call frmGeneral.UpdateMenuMaps
    
End Sub

Sub OpenMap(f As Integer, filename As String)
'Opens a map
    Dim b(3) As Byte
    
    Open filename For Binary As #f
        Get #f, , b
    
        If Chr(b(0)) & Chr(b(1)) <> "BM" Then
            'there is no tileset attached to the map
            'so the default will be used
            'default on true
            usingDefaultTileset = True
            'update menu
            frmGeneral.mnudiscardtileset.Enabled = False
            frmGeneral.mnuExportTileset.Enabled = False
            'resize magnifier.zoom tileset
            'reset position
            Seek #f, 1
            'Now we are at the correct position for the tiles
        Else
            'update the menu's
            frmGeneral.mnudiscardtileset.Enabled = True
            frmGeneral.mnuExportTileset.Enabled = True
            'rewind to beginning
            Seek #f, 1
            Get #f, , BMPFileHeader
            Get #f, , BMPInfoHeader
            'check if its 8/24 bit, normally it would be else we
            'have a corrupt lvl file
            'but check anyway
            If BMPInfoHeader.biBitCount < 8 Then
                MsgBox "Invalid tileset within lvl file!"
                Close #f
                Exit Sub
            End If
            
            If BMPInfoHeader.biBitCount = 8 Then
                ReDim BMPRGBQuad(255)
                Get #f, , BMPRGBQuad
            Else
                'skip because everything bigger than 8-bit depth
                'wont be using a rgbquad anymore
            End If
            
            'resize bmpdata
            ReDim BMPData(BMPInfoHeader.biSizeImage)
            
            Get #f, , BMPData
            
            'now seek to the part where the map bytes are stored
            Seek #f, (BMPFileHeader.bfSize + 1)
        
            'this is the end of the tileset, tiles should start here
        End If

        'update the tileset
        If usingDefaultTileset Then
            Call InitTileset("")
        Else
            Call InitTileset(filename)
        End If
        
        'keep em coming till we have reached the end of the file
        Do Until EOF(f)
            Dim x As Integer
            Dim y As Integer
               
            'retrieve 4 bytes
            Get #f, , b
            
            'extract the data
            x = b(0) + 256 * (b(1) Mod 16)
            y = b(1) \ 16 + 16 * b(2)
            
            If tile(x, y) <> 0 Then
                'tile has already come, skip it, prolly last tile
            Else
                tile(x, y) = b(3)
            End If
            
        Loop
    Close #f
    
    'we load so we have a path
    activeFile = filename
    
    'add this to recent
    Call frmGeneral.AddRecent(filename)
    
    'just opened so the map hasn't changed yet
    mapchanged = False
    
    
    dontUpdateOnValueChange = True
    UpdateScrollBars (False)
    'same as with new map, go to center of the map
    hScr.value = Int(Int(hScr.Max / 2) / TileW) * TileW
    vscr.value = Int(Int(vscr.Max / 2) / TileH) * TileH
    dontUpdateOnValueChange = False
    
    'draw the full map used for radar or usingpixels magnifier.zoom level
    Dim i As Integer
    Dim j As Integer
    For j = 0 To 1023
        For i = 0 To 1023
            'when an object is special, flag the other
            'tiles to -1 so that we know we are in an object
            Call CompleteSpecialTiles(i, j)
            
            'draw the complete pixel map
            If tile(i, j) <> 0 Then
                Call SetPixel(pic1024.hdc, i, j, TilePixelColor(tile(i, j)))
            End If
        Next
    Next
    
    Call frmGeneral.UpdateMenuMaps
    
End Sub

Sub SaveMap(path As String, Optional SSMECompatible As Boolean = False)
Dim defaultChanged As Boolean

'Saves the map

    'back the old one up
    'if there is already a backup, kill it
    'then rename the new old one to the .bak one
    If Dir$(path) <> "" Then
        If Dir$(path & ".bak") <> "" Then
            Kill path & ".bak"
        End If
        Name path As path & ".bak"
    End If
    
    Dim f As Integer
    f = FreeFile
    Open path For Binary As #f
        
        
        defaultChanged = False

        If usingDefaultTileset Then
            'Compare the real default tileset with the current default.bmp
            
            Dim i As Integer
            Dim j As Integer
            
            For i = 0 To frmGeneral.picdefaulttileset.ScaleWidth - 1
                For j = 0 To frmGeneral.picdefaulttileset.ScaleHeight - 1
                    If GetPixel(frmGeneral.picdefaulttileset.hdc, i, j) <> GetPixel(pictileset.hdc, i, j) Then
                        defaultChanged = True
                        Call ImportTileset(App.path & "\default.bmp")
                        Exit For
                    End If
                Next j
                If defaultChanged = True Then Exit For
            Next i
        End If
        
        If usingDefaultTileset = True And defaultChanged = False Then
            'no need to write the bmp
            'just begin writing the tile data
        Else
            'put the bitmap data first
            Put #f, , BMPFileHeader
            Put #f, , BMPInfoHeader
            
            If BMPInfoHeader.biBitCount = 8 Then
                Put #f, , BMPRGBQuad
            End If
            
            Put #f, , BMPData
            
            'once all the bmp data is put, continue at the position for
            'the map data
            Seek #f, (BMPFileHeader.bfSize + 1)
        End If
        
        Dim x As Integer
        Dim y As Integer
        
        For y = 0 To 1023
            For x = 0 To 1023
                'watch out for special tile flagging !, but
                'those will be 0 anyway, so skip them too
                If tile(x, y) <> 0 And tile(x, y) <> -1 Then
                    'if ssme compatible is required, discard all tiles
                    'above 190 except for the ones that ssme does recognize
                    If SSMECompatible And tile(x, y) > 190 And _
                       tile(x, y) <> 216 And tile(x, y) <> 217 And _
                       tile(x, y) <> 218 And tile(x, y) <> 219 And _
                       tile(x, y) <> 220 Then
                        'do not save those not compatible with ssme
                    Else
                        'to calculate to bytes again :
                        Dim reb(3) As Byte
                        reb(0) = x Mod 256 'bottom 8 of x
                        reb(2) = y \ 16 'top 8 of y
                        'calculate b(1) out of y, but add the remainder from the x
                        'equation because when y is calculated, it's rounded
                        'down and the remainder is lost
                        reb(1) = (y - 16 * reb(2)) * 16 + (x - reb(0)) / 256
                        
                        reb(3) = CByte(tile(x, y))
                        
                        'now put the bytes
                        Put #f, , reb(0)
                        Put #f, , reb(1)
                        Put #f, , reb(2)
                        Put #f, , reb(3)
                    End If
                Else
                    'dont save those empty tiles
                End If
            Next
        Next
    Close #f
    
    
    If Not SSMECompatible Then
        mapchanged = False
    Else
        'no mapchanged, as some data could be lost
    End If
    
    Call frmGeneral.UpdateMenuMaps
    
End Sub

Sub CompleteSpecialTiles(x As Integer, y As Integer)
'Completes special tiles
    Dim i As Integer
    Dim j As Integer
    
    Select Case tile(x, y)
        Case 217
            tile(x + 1, y) = -1
            tile(x, y + 1) = -1
            tile(x + 1, y + 1) = -1
        Case 219
            For j = y To y + 5
                For i = x To x + 5
                    tile(i, j) = -1
                Next
            Next
            tile(x, y) = 219
        Case 220
            For j = y To y + 4
                For i = x To x + 4
                    tile(i, j) = -1
                Next
            Next
            tile(x, y) = 220
        Case Else
            'do nothing
    End Select
End Sub

Sub SwitchOrReplace(src As Integer, dest As Integer, replace As Boolean)
'Switches or replaces tiles on the entire map
    
    Dim i As Integer
    Dim j As Integer
    
    '2 counters that hold how many tiles are replaced or switched
    Dim n As Long
    Dim m As Long
    
    'prepare the undoch
    undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes
    
    n = 0
    m = 0
    
    For j = 0 To 1023
        For i = 0 To 1023
            'replace the src tile with the dest tile
            If tile(i, j) = src Then
                Call setTile(i, j, dest, undoch)
                Call UpdateLevelTile(i, j, False)
                n = n + 1
            'if the tile is a dest tile and we switch
            'then we replace it with the src tile
            ElseIf tile(i, j) = dest And Not replace Then
                Call setTile(i, j, src, undoch)
                Call UpdateLevelTile(i, j, False)
                m = m + 1
            End If
        Next
    Next
    
    'show the results of the operation
    If replace Then
        MsgBox n & " tiles replaced.", vbOKOnly, "Tiles replaced"
    Else
        MsgBox n & " tiles A -> B" & vbCrLf & m & " tiles A <- B", vbOKOnly, "Tiles switched"
    End If
    
    'add the changes to the undo stack
    Call undoredo.AddToUndo(undoch)
    
    'update the level
    Call UpdateLevel
    
    'map has changed
    mapchanged = True
End Sub

Sub CountTiles()
'Counts the tiles on the map (or in selection), such as the selected tiles in the tileset,
'special tiles
    Dim i As Integer
    Dim j As Integer
    
    'Will hold each tile's count
    Dim tilecount(255) As Long
    
    'holds the boundaries to scan in
    Dim lbx As Integer
    Dim ubx As Integer
    Dim lby As Integer
    Dim uby As Integer

    'selection is already moved, so the area doesn't match with the tiles
    If sel.selalreadymoved = True Then
        MsgBox "Cannot count tiles after selection was moved."
        Exit Sub
    End If
    
    'reset counters
    For i = 0 To 255
        tilecount(i) = 0
    Next i

    
    'put the correct boundaries
    If sel.selstate = append Then
        lbx = sel.seltilestartx
        ubx = sel.seltileendx
        lby = sel.seltilestarty
        uby = sel.seltileendy
    Else
        lbx = 0
        ubx = 1023
        lby = 0
        uby = 1023
    End If
        
    
        'count the tiles in the area, when a special tile is selected
        'count it once with n or m and once with special
        For j = lby To uby
             For i = lbx To ubx
                If tile(i, j) = 0 Or tile(i, j) = -1 Then
                    'do nothing
                Else
                    tilecount(tile(i, j)) = tilecount(tile(i, j)) + 1
                End If
            Next
        Next
        
        'store values in frmCount
        For i = 0 To 255
            Call frmCount.StoreValues(i, tilecount(i))
        Next i
        
        'tell frmCount if tiles were counted in selection only or not
        If sel.selstate = append Then
            frmCount.inselection = True
        Else
            frmCount.inselection = False
        End If
        
        'tell frmCount which tiles are selected
        frmCount.tilesetleft = tilesetleft
        frmCount.tilesetright = tilesetright
        
        frmCount.Show
        
End Sub

Sub setScrollBarValues(h As Integer, v As Integer, Optional refresh As Boolean)
'Set the scrollbar values on the given coordinates
    dontUpdateOnValueChange = Not refresh
    Call UpdateScrollBars(refresh)
    If h > hScr.Max Then
        hScr.value = hScr.Max
    Else
        hScr.value = h
    End If
    
    If v > vscr.Max Then
        vscr.value = vscr.Max
    Else
        vscr.value = v
    End If

    
    dontUpdateOnValueChange = refresh
End Sub

Sub UpdateScrollBars(Optional refresh As Boolean = False)
'put the scrollbars, but don't update the level

    
    dontUpdateOnValueChange = Not refresh
    
    hScr.Max = 1024 * TileW * magnifier.Zoom - (Int(picpreview.Width / (TileW * magnifier.Zoom))) * (TileW * magnifier.Zoom)
    hScr.LargeChange = (TileW * magnifier.Zoom) * 10
    hScr.SmallChange = (TileW * magnifier.Zoom)
    

    
    vscr.Max = 1024 * TileH * magnifier.Zoom - (Int(picpreview.Height / (TileH * magnifier.Zoom))) * (TileH * magnifier.Zoom)
    vscr.LargeChange = (TileH * magnifier.Zoom) * 10
    vscr.SmallChange = (TileH * magnifier.Zoom)
    

End Sub

Sub UpdateLevel()
'Updates the level
    Dim i As Integer
    Dim j As Integer

    'CALCULATE BOUNDARIES OF PICLEVEL
    Dim lbx As Integer 'lowestval for x
    Dim hbx As Integer 'highestval for x
    Dim lby As Integer 'lowestval for y
    Dim hby As Integer 'highestval for y
    lbx = Int(hScr.value / (TileW * magnifier.Zoom))
    hbx = Int((hScr.value + picpreview.Width) / (TileW * magnifier.Zoom))
    lby = Int(vscr.value / (TileH * magnifier.Zoom))
    hby = Int((vscr.value + picpreview.Height) / (TileH * magnifier.Zoom))

    piclevel.Cls

    If magnifier.UsingPixels Then
                
        'just copy a part of the pixel map if we are using pixels
        BitBlt piclevel.hdc, 0, 0, piclevel.Width, piclevel.Height, pic1024.hdc, lbx, lby, vbSrcCopy
        
        'draw grid if needed
        If usinggrid Then
            DrawGrid
        End If

    Else
        'draw grid if needed
        If usinggrid Then
            DrawGrid
        End If

        'stretchblt is waaaaaaaay slower than blt, so it wasn't a good
        'idea to directly strectch from the tileset to the map
        'because i lost so much performance i reverted the changes
        'back to the magnifier.zoomed tileset
        'and i mean WAY slower, like 1 sec for bitblting took like
        ' 5-6sec for stretchblting, which is not acceptable if we
        'have scrollbars that rely on this
        
        'draw every tile that is within the visible part
        For j = lby To hby
            For i = lbx To hbx
                If Not (i < 0 Or j < 0 Or i > 1023 Or j > 1023) Then
                    If tile(i, j) = 217 Then
                        SetStretchBltMode piclevel.hdc, HALFTONE
                        StretchBlt piclevel.hdc, (i - lbx) * (TileW * magnifier.Zoom), (j - lby) * (TileH * magnifier.Zoom), 2 * (TileW * magnifier.Zoom), 2 * (TileH * magnifier.Zoom), frmGeneral.picspecial.hdc, 16, 0, 2 * TileW, 2 * TileH, vbSrcCopy
                    ElseIf tile(i, j) = 219 Then
                        SetStretchBltMode piclevel.hdc, HALFTONE
                        StretchBlt piclevel.hdc, (i - lbx) * (TileW * magnifier.Zoom), (j - lby) * (TileH * magnifier.Zoom), 6 * (TileW * magnifier.Zoom), 6 * (TileH * magnifier.Zoom), frmGeneral.picspecial.hdc, 128, 0, 6 * TileW, 6 * TileH, vbSrcCopy
                    ElseIf tile(i, j) = 220 Then
                        SetStretchBltMode piclevel.hdc, HALFTONE
                        StretchBlt piclevel.hdc, (i - lbx) * (TileW * magnifier.Zoom), (j - lby) * (TileH * magnifier.Zoom), 5 * (TileW * magnifier.Zoom), 5 * (TileH * magnifier.Zoom), frmGeneral.picspecial.hdc, 48, 0, 5 * TileW, 5 * TileH, vbSrcCopy
                    ElseIf tile(i, j) <> 0 Then
                        BitBlt piclevel.hdc, (i - lbx) * (TileW * magnifier.Zoom), (j - lby) * (TileH * magnifier.Zoom), (TileW * magnifier.Zoom), (TileH * magnifier.Zoom), piczoomtileset.hdc, ((tile(i, j) - 1) Mod 19) * (TileW * magnifier.Zoom), Int((tile(i, j) - 1) / 19) * (TileH * magnifier.Zoom), vbSrcCopy
                    End If
        
                    'only show tilenrs if magnifier.zoom is 1 or 2, any more magnifier.zoomed
                    'out will just be unreadable
                    If (magnifier.Zoom = 1 Or magnifier.Zoom = 2) And _
                       usingtilenr Then
                        'draw the tile numbers
                        piclevel.ForeColor = vbWhite
                        piclevel.CurrentX = (i - lbx) * (TileW * magnifier.Zoom)
                        piclevel.CurrentY = (j - lby) * (TileH * magnifier.Zoom)
                        piclevel.Print tile(i, j)
                    End If
                End If
            Next
        Next
    End If
    
    piclevel.refresh
        
    If sel.selstate = append Then
        'if there is a selection, update the selection too
        Call sel.UpdateSelectionOnPreview
    End If

    'now the level map is updated, update the preview now
    UpdatePreview
End Sub

Sub UpdateLevelTile(x As Integer, y As Integer, Optional refresh As Boolean = True)
'Update a specific tile
    Dim lbx As Integer 'lowestval for x
    Dim hbx As Integer 'highestval for x
    Dim lby As Integer 'lowestval for y
    Dim hby As Integer 'highestval for y
    
    'calculate the boundaries of the current preview
    'in tile x and tile y coordinates
    lbx = Int(hScr.value / (TileW * magnifier.Zoom))
    hbx = Int((hScr.value + picpreview.Width) / (TileW * magnifier.Zoom))
    lby = Int(vscr.value / (TileH * magnifier.Zoom))
    hby = Int((vscr.value + picpreview.Height) / (TileH * magnifier.Zoom))
    
    'draw the according pixel on the radar
    Call SetPixel(pic1024.hdc, x, y, TilePixelColor(tile(x, y)))

    'dont draw if it's not visible, once it will be visible,
    'updatelevel is called anyway
    If x < lbx Or x > hbx Then
        Exit Sub
    End If
    If y < lby Or y > hby Then
        Exit Sub
    End If
        
    If magnifier.UsingPixels Then
        'when only using pixels, it will copy the picture from
        'pic1024, which is only 1 blt, so much easier this way
        'else redrawing the whole level not on pixel level is way
        'too much demanding
        If refresh Then
            UpdateLevel
        End If
    Else
        If tile(x, y) = 217 Then
            SetStretchBltMode piclevel.hdc, HALFTONE
            StretchBlt piclevel.hdc, (x - lbx) * (TileW * magnifier.Zoom), (y - lby) * (TileH * magnifier.Zoom), 2 * (TileW * magnifier.Zoom), 2 * (TileH * magnifier.Zoom), frmGeneral.picspecial.hdc, 16, 0, 2 * TileW, 2 * TileH, vbSrcCopy
        ElseIf tile(x, y) = 219 Then
            SetStretchBltMode piclevel.hdc, HALFTONE
            StretchBlt piclevel.hdc, (x - lbx) * (TileW * magnifier.Zoom), (y - lby) * (TileH * magnifier.Zoom), 6 * (TileW * magnifier.Zoom), 6 * (TileH * magnifier.Zoom), frmGeneral.picspecial.hdc, 128, 0, 6 * TileW, 6 * TileH, vbSrcCopy
        ElseIf tile(x, y) = 220 Then
            SetStretchBltMode piclevel.hdc, HALFTONE
            StretchBlt piclevel.hdc, (x - lbx) * (TileW * magnifier.Zoom), (y - lby) * (TileH * magnifier.Zoom), 5 * (TileW * magnifier.Zoom), 5 * (TileH * magnifier.Zoom), frmGeneral.picspecial.hdc, 48, 0, 5 * TileW, 5 * TileH, vbSrcCopy
        ElseIf tile(x, y) <> 0 Then
            BitBlt piclevel.hdc, (x - lbx) * (TileW * magnifier.Zoom), (y - lby) * (TileH * magnifier.Zoom), (TileW * magnifier.Zoom), (TileH * magnifier.Zoom), piczoomtileset.hdc, ((tile(x, y) - 1) Mod 19) * (TileW * magnifier.Zoom), Int((tile(x, y) - 1) / 19) * (TileH * magnifier.Zoom), vbSrcCopy
        Else
            picempty.Width = TileW * magnifier.Zoom
            picempty.Height = TileH * magnifier.Zoom
            BitBlt piclevel.hdc, (x - lbx) * (TileW * magnifier.Zoom), (y - lby) * (TileH * magnifier.Zoom), (TileW * magnifier.Zoom), (TileH * magnifier.Zoom), picempty.hdc, 0, 0, vbSrcCopy
        End If

        'same here, don't show the tilenrs of the updated tile
        'if not onmagnifier.zoom 1 ormagnifier.zoom 2
        If (magnifier.Zoom = 1 Or magnifier.Zoom = 2) And _
           usingtilenr Then
            piclevel.ForeColor = vbWhite
            piclevel.CurrentX = (x - lbx) * (TileW * magnifier.Zoom)
            piclevel.CurrentY = (y - lby) * (TileH * magnifier.Zoom)
            piclevel.Print tile(x, y)
        End If

        If refresh Then
            'show it directly on the map so refresh
            piclevel.refresh
            UpdatePreview
        End If
    End If

End Sub

Sub UpdatePreview(Optional refresh As Boolean = True)
'Updates the preview and radar

    Dim i As Integer
        
    'get data from level map
    BitBlt picpreview.hdc, 0, 0, picpreview.Width, picpreview.Height, piclevel.hdc, 0, 0, vbSrcCopy

    'if there is a selection, update it too
    If (curtool = T_selection Or curtool = T_magnifier Or T_hand) And sel.selstate = append Then
        sel.UpdateSelectionOnPreview
    End If

    If refresh Then picpreview.refresh


    '///////////////// RADAR UPDATE ////////////////
        
    Dim centralx As Integer
    Dim centraly As Integer
    
    'clear the picradar
    frmGeneral.picradar.Cls
    
    'calculate the central tile x and tile y
    centralx = (hScr.value / (TileW * magnifier.Zoom)) + (picpreview.Width / (TileW * magnifier.Zoom)) / 2
    centraly = (vscr.value / (TileH * magnifier.Zoom)) + (picpreview.Height / (TileH * magnifier.Zoom)) / 2
    
    Dim lbx As Integer
    Dim lby As Integer
    'calculates the lbx and lby of the radar
    
    lbx = centralx - (frmGeneral.picradar.Width / 2) - 2
    lby = centraly - (frmGeneral.picradar.Height / 2) - 2
       

    'if we click on the radar, we still need to know our position
    'of the preview ... actually come to think of it, i could just
    'recalculate it from preview, but this is more .. err.. certain
    'that it will work
    
    
    radar_left = lbx
    radar_top = lby
    
    'draw the correct portion of the pixel map to the radar
    Call BitBlt(frmGeneral.picradar.hdc, 0, 0, frmGeneral.picradar.Width - 1, frmGeneral.picradar.Height - 1, pic1024.hdc, Int(lbx) - 1, Int(lby) - 1, vbSrcCopy)
    
    'draw the A1-T20 grid above it (opacity = 40%)
    Dim a As Integer
    Dim b As Integer
    Dim color As Long
    Dim getp As Long
    
    Const alpha = 0.6
    frmGeneral.picradar.ForeColor = RGB(0, 100, 0)
    For a = Int(lbx / Int(1024 / 20)) * Int(1024 / 20) To lbx + frmGeneral.picradar.Width Step 51
        For b = 0 To frmGeneral.picradar.Height
            If (a + lbx > 0 And b + lby > 0 And a + lbx < 1024 And b + lby < 1024) Then
                getp = TilePixelColor(tile(a - lbx + lbx, b + lby))
            Else
                getp = RGB(0, 0, 0)
            End If
            color = RGB(GetRED(getp) * alpha + 0 * (1 - alpha), GetGREEN(getp) * alpha + 150 * (1 - alpha), GetBLUE(getp) * alpha + 0 * (1 - alpha))
  '          Call SetPixel(frmGeneral.picradar.hdc, a - lbx, b, color)
        Next
  '      frmGeneral.picradar.Line (a - lbx, 0)-(a - lbx, frmGeneral.picradar.Height)
    Next
    For a = Int(lby / Int(1024 / 20)) * Int(1024 / 20) To lby + frmGeneral.picradar.Height Step Int((1024 / 20))
        For b = 0 To frmGeneral.picradar.Width
            If (a + lby > 0 And b + lbx > 0 And a + lby < 1024 And b + lbx < 1024) Then
                getp = TilePixelColor(tile(b + lbx, a - lby + lby))
            Else
                getp = RGB(0, 0, 0)
            End If
            color = RGB(GetRED(getp) * alpha + 0 * (1 - alpha), GetGREEN(getp) * alpha + 150 * (1 - alpha), GetBLUE(getp) * alpha + 0 * (1 - alpha))
   '         Call SetPixel(frmGeneral.picradar.hdc, b, a - lby, color)
        Next
   '     frmGeneral.picradar.Line (0, a - lby)-(frmGeneral.picradar.Width, a - lby)
    Next

    
    
    'calculate the correct position of the preview rectangle onto the radar
    Dim nrofpixelsleft As Integer
    nrofpixelsleft = (picpreview.Width / (TileW * magnifier.Zoom)) / 2 - 1
    Dim nrofpixelstop As Integer
    nrofpixelstop = (picpreview.Height / (TileH * magnifier.Zoom)) / 2 - 1
    
    'draw the red rectangle
    Call DrawRectangle(frmGeneral.picradar, _
                       (frmGeneral.picradar.Width / 2) - nrofpixelsleft, _
                       (frmGeneral.picradar.Width / 2) + nrofpixelsleft + 2, _
                       (frmGeneral.picradar.Height / 2) - nrofpixelstop, _
                       (frmGeneral.picradar.Height / 2) + nrofpixelstop + 2, vbRed)
    
    'if we have a selection, draw it on the radar with a dotted yellow rectangle
    If (curtool = T_selection Or curtool = T_magnifier) And (sel.selstate = append Or sel.selstate = drawing) Then
        'make it dashed
        frmGeneral.picradar.DrawStyle = 2
        
        'this is the the same offsets as the picpreview rectangle above, plus
        'the offset of the selection shape
        Call DrawRectangle(frmGeneral.picradar, ((frmGeneral.picradar.Width / 2) - nrofpixelsleft) + shpdraw.Left / (TileW * magnifier.Zoom) + 1, _
                           ((frmGeneral.picradar.Width / 2) - nrofpixelsleft) + (shpdraw.Left + shpdraw.Width) / (TileW * magnifier.Zoom) + 1, _
                           ((frmGeneral.picradar.Height / 2) - nrofpixelstop) + shpdraw.Top / (TileH * magnifier.Zoom) + 1, _
                           ((frmGeneral.picradar.Height / 2) - nrofpixelstop) + (shpdraw.Top + shpdraw.Height) / (TileH * magnifier.Zoom) + 1, _
                           vbYellow)
        'put it back to solid
        frmGeneral.picradar.DrawStyle = 0
    End If
    
    
    'draw the center lines with dotted blue lines
    If lby > 512 - frmGeneral.picradar.Height And lby < 512 Then
            frmGeneral.picradar.ForeColor = RGB(0, 0, 200)
           frmGeneral.picradar.DrawStyle = 2
            frmGeneral.picradar.Line (0, 512 - lby)-(frmGeneral.picradar.Width, 512 - lby)
            frmGeneral.picradar.DrawStyle = 0
    End If
    If lbx > 512 - frmGeneral.picradar.Width And lbx < 512 Then
            frmGeneral.picradar.ForeColor = RGB(0, 0, 200)
            frmGeneral.picradar.DrawStyle = 2
            frmGeneral.picradar.Line (512 - lbx, 0)-(512 - lbx, frmGeneral.picradar.Height)
            frmGeneral.picradar.DrawStyle = 0
    End If

    ''fill the boundaries of the level on the map with grey lines
    If lbx < 0 Then
        frmGeneral.picradar.ForeColor = RGB(80, 80, 80)
        For i = 0 To Abs(lbx)
            frmGeneral.picradar.Line (i, 0)-(i, frmGeneral.picradar.Height)
        Next i
    End If
    If lby < 0 Then
        frmGeneral.picradar.ForeColor = RGB(80, 80, 80)
        For i = 0 To Abs(lby)
            frmGeneral.picradar.Line (0, i)-(frmGeneral.picradar.Height, i)
        Next i
    End If
    If lbx + frmGeneral.picradar.Width > 1024 Then
        frmGeneral.picradar.ForeColor = RGB(80, 80, 80)
        For i = 1024 - lbx + 1 To frmGeneral.picradar.Width
            frmGeneral.picradar.Line (i, 0)-(i, frmGeneral.picradar.Height)
        Next i
    
    End If
    If lby + frmGeneral.picradar.Height > 1024 Then
        frmGeneral.picradar.ForeColor = RGB(80, 80, 80)
        For i = 1024 - lby + 1 To frmGeneral.picradar.Height
            frmGeneral.picradar.Line (0, i)-(frmGeneral.picradar.Width, i)
        Next i
    End If
   
    

        
    'refresh the radar
    frmGeneral.picradar.refresh
    

End Sub



Private Sub DrawGrid()
'Draws the grid

    'CALCULATE BOUNDARIES OF PICLEVEL
    Dim lbx As Integer 'lowestval for x
    Dim hbx As Integer 'highestval for x
    Dim lby As Integer 'lowestval for y
    Dim hby As Integer 'highestval for y
    lbx = Int(hScr.value / (TileW * magnifier.Zoom))
    hbx = Int((hScr.value + picpreview.Width) / (TileW * magnifier.Zoom))
    lby = Int(vscr.value / (TileH * magnifier.Zoom))
    hby = Int((vscr.value + picpreview.Height) / (TileH * magnifier.Zoom))
    
    'no use drawing a grid every pixel, it will generate a grey image

    
    Dim i As Integer
    Dim j As Integer
    

    'calculate the width and height of the lines
    Dim w As Integer
    If hbx > 1024 Then
        w = piclevel.Width - ((hbx - 1024 - 1) * (TileW * magnifier.Zoom))
    Else
        w = piclevel.Width
    End If
    
    Dim h As Integer
    If hby > 1024 Then
        h = piclevel.Height - ((hby - 1024 - 1) * (TileH * magnifier.Zoom))
    Else
        h = piclevel.Height
    End If
    
    'round the width and height of the lines to the tiles if we encounter
    'a border
    

    'draw the vertical lines
    For j = 0 To w Step (TileW * magnifier.Zoom)
    
        'Define the color of the grid line
        If lbx * (TileW) + j = 0 _
            Or (lbx * TileW * magnifier.Zoom) + j = 1024 * TileW * magnifier.Zoom Then
            piclevel.ForeColor = RGB(255, 255, 255)
        ElseIf (lbx * TileW * magnifier.Zoom) + j = 512 * TileW * magnifier.Zoom Then
            piclevel.ForeColor = RGB(0, 0, 200)
        ElseIf (lbx * (TileW * magnifier.Zoom) + j) Mod (Int((1024 / 20) * 4) * TileW * magnifier.Zoom) = 0 Then
            piclevel.ForeColor = RGB(200, 0, 0)
        ElseIf (lbx * (TileW * magnifier.Zoom) + j) Mod (Int((1024 / 20)) * TileW * magnifier.Zoom) = 0 Then
            piclevel.ForeColor = RGB(150, 150, 150)
        Else
            If magnifier.UsingPixels Then GoTo nextV
            piclevel.ForeColor = RGB(80, 80, 80)
        End If
        
        'Draw the grid line
        piclevel.Line (j, 0)-(j, IIf(hby > 1023, Int(h / (TileH * magnifier.Zoom)) * (TileH * magnifier.Zoom), h))
nextV:
    Next
    
    'draw the horizontal lines
    For i = 0 To h Step (TileH * magnifier.Zoom)
        
        'Define the color of the grid line
        If lby * (TileH) + i = 0 _
            Or (lby * TileW * magnifier.Zoom) + i = 1024 * TileW * magnifier.Zoom Then
            piclevel.ForeColor = RGB(255, 255, 255)
        ElseIf (lby * TileW * magnifier.Zoom) + i = 512 * TileW * magnifier.Zoom Then
            piclevel.ForeColor = RGB(0, 0, 200)
        'ElseIf (lby * (TileW * magnifier.Zoom) + i) Mod (256 * TileW * magnifier.Zoom) = 0 Then
        ElseIf (lby * (TileW * magnifier.Zoom) + i) Mod (Int((1024 / 20) * 4) * TileW * magnifier.Zoom) = 0 Then
            piclevel.ForeColor = RGB(200, 0, 0)
        'ElseIf (lby * (TileW * magnifier.Zoom) + i) Mod (32 * TileW * magnifier.Zoom) = 0 Then
        ElseIf (lby * (TileW * magnifier.Zoom) + i) Mod (Int((1024 / 20)) * TileW * magnifier.Zoom) = 0 Then
            piclevel.ForeColor = RGB(150, 150, 150)
        Else
            If magnifier.UsingPixels Then GoTo nextH
            piclevel.ForeColor = RGB(80, 80, 80)
        End If
        

        'Draw the grid line
        piclevel.Line (0, i)-(IIf(hbx > 1023, Int(w / (TileW * magnifier.Zoom)) * (TileW * magnifier.Zoom), w), i)
nextH:
    Next
End Sub

Sub UseShortcutTool(KeyDown As Boolean, KeyCode As Integer, Shift As Integer)
'Uses hotkeys to swap to different tools and such
    If KeyDown And Not Shift = 2 And Not Shift = 1 Then
        Select Case KeyCode
            Case vbKeyEscape
                'stop selection when pressing esc
                If curtool = T_selection And sel.selstate = append Then
                    sel.StopSelecting
                End If
                
            Case vbKeyDelete
                'deletes the selection
                If curtool = T_selection And sel.selstate = append Then
                    sel.DeleteSelection
                End If
            
            Case vbKeyH
                frmGeneral.SetCurrentTool (T_hand)
            Case vbKeyP
                frmGeneral.SetCurrentTool (t_pencil)
            Case vbKeyE
                frmGeneral.SetCurrentTool (T_Eraser)
            Case vbKeyS
                frmGeneral.SetCurrentTool (T_selection)
            Case vbKeyD
                frmGeneral.SetCurrentTool (t_dropper)
            Case vbKeyZ
                frmGeneral.SetCurrentTool (T_magnifier)
            Case vbKeyF
                frmGeneral.SetCurrentTool (t_bucket)
            Case vbKeyL
                frmGeneral.SetCurrentTool (T_line)
            Case vbKeyR
                frmGeneral.SetCurrentTool (T_rectangle)
            Case vbKeyO
                frmGeneral.SetCurrentTool (T_ellipse)
            Case vbKeyI
                frmGeneral.SetCurrentTool (t_spline)
            Case vbKeyA
                frmGeneral.SetCurrentTool (T_airbrush)
            Case vbKeyG
                frmGeneral.ToggleGrid
            Case vbKeyT
                frmGeneral.ToggleTileNr
            
            Case vbKeyLeft
                'move the map 10 tiles to the left
                If hScr.value - (10 * TileW) < 0 Then
                    hScr.value = 0
                Else
                    hScr.value = hScr.value - (10 * TileW)
                End If
            
            Case vbKeyRight
                'move the map 10 tiles to the right
                If hScr.value + (10 * TileW) > hScr.Max Then
                    hScr.value = hScr.Max
                Else
                    hScr.value = hScr.value + (10 * TileW)
                End If
                
            Case vbKeyUp
                'move the map 10 tiles up
                If vscr.value - (10 * TileH) < 0 Then
                    vscr.value = 0
                Else
                    vscr.value = vscr.value - (10 * TileH)
                End If
            
            Case vbKeyDown
                'move the map 10 tiles down
            If vscr.value + (10 * TileH) > vscr.Max Then
                vscr.value = vscr.Max
            Else
                vscr.value = vscr.value + (10 * TileH)
            End If
            
            Case vbKey0 To vbKey9
                Call GotoBookMark(KeyCode - vbKey0)
        End Select
    ElseIf KeyDown And Shift = 1 And KeyCode >= vbKey0 And KeyCode <= vbKey9 Then
        Call SetBookMark(KeyCode - vbKey0)
    ElseIf KeyDown And Shift = 2 And (curtool = t_pencil Or curtool = t_bucket) Then
        'if we press ctrl and we use pencil or bucket, use the dropper
        tempdropping = True
        toolbeforetempdropping = curtool
        Call frmGeneral.SetCurrentTool(t_dropper)
    Else
        'not pressing ctrl anymore, use the tool before dropping
        If Shift = 0 And tempdropping Then
            tempdropping = False
            Call frmGeneral.SetCurrentTool(toolbeforetempdropping)
        End If
    End If
    
End Sub

Sub SetBookMark(index As Integer)
    Dim x As Integer
    Dim y As Integer
    x = (hScr.value + picpreview.Width / 2) / (TileW * magnifier.Zoom)
    y = (vscr.value + picpreview.Height / 2) / (TileH * magnifier.Zoom)
    
    bookmark(index) = CLng(y) * 1024 + x
End Sub

Sub GotoBookMark(index As Integer)
    If bookmark(index) = 0 Then
        'no bookmark defined
    Else
        Dim x As Integer
        Dim y As Integer
        x = bookmark(index) Mod 1024
        y = Int(bookmark(index) / 1024)
        Call frmGeneral.ExecuteGoTo(x, y)
    End If
    
End Sub
Private Sub CheckShiftCtrl(Shift As Integer, curtilex As Integer, curtiley As Integer)
'Checks if we pressed shift or ctrl
    Dim diagdist As Integer
    tempx = curtilex
    tempy = curtiley
        If Shift Mod 2 = 1 Then
            Select Case curtool
                Case T_line, t_spline
                    ' calculate the distance of the diagonal
                    diagdist = 0.25 * (((curtilex - fromtilex) ^ 2) + ((curtiley - fromtiley) ^ 2)) ^ 0.5
                    If (Abs(curtiley - fromtiley) - Abs(curtilex - fromtilex)) < diagdist And (Abs(curtiley - fromtiley) - Abs(curtilex - fromtilex)) > -1 * diagdist Then
                        If ((curtiley - fromtiley) < 0 And (curtilex - fromtilex) > 0) Or ((curtiley - fromtiley) > 0 And (curtilex - fromtilex) < 0) Then
                            tempy = fromtiley - (curtilex - fromtilex) ' / Diagonals
                        Else
                            tempy = fromtiley + (curtilex - fromtilex) ' \ Diagonals
                        End If
                        
                    Else
                        If Abs(curtiley - fromtiley) > Abs(curtilex - fromtilex) Then 'Straight lines
                            tempx = fromtilex
                        Else
                            tempy = fromtiley
                        End If
                    End If
                    
                Case T_rectangle, T_ellipse, T_selection, T_filledellipse, T_filledrectangle
                    If ((curtiley - fromtiley) < 0 And (curtilex - fromtilex) > 0) Or ((curtiley - fromtiley) > 0 And (curtilex - fromtilex) < 0) Then
                        If Abs(curtilex - fromtilex) > Abs(curtiley - fromtiley) Then
                            tempy = fromtiley - (curtilex - fromtilex)
                        Else
                            tempx = fromtilex - (curtiley - fromtiley)
                        End If
                    Else
                        If Abs(curtilex - fromtilex) > Abs(curtiley - fromtiley) Then
                            tempy = fromtiley + (curtilex - fromtilex)
                        Else
                            tempx = fromtilex + (curtiley - fromtiley)
                        End If
                    End If
            End Select
        End If
        
        If Shift = 2 Or Shift = 3 Or Shift = 6 Then
            usingctrl = True
        Else
            usingctrl = False
        End If
End Sub

Function CountFlags() As Long
'Count the number of flags in the map
    Dim flags As Long
    Dim i As Integer
    Dim j As Integer
    
    flags = 0
    For j = 0 To 1023
        For i = 0 To 1023
            'tile 170 = flag
            If tile(i, j) = 170 Then
                flags = flags + 1
            End If
        Next
    Next
    
    CountFlags = flags
End Function

Sub DragMap(x As Single, y As Single, Shift As Integer)
    Dim Speed As Integer

    'Speed up the process if holding Alt key
    If Shift = 4 Or Shift = 5 Or Shift = 6 Or Shift = 7 Then
        Speed = 25
    Else
        Speed = 5
    End If


    If x < 0 Then
                'move the map X tile to the left
                If hScr.value - Speed * (TileW * magnifier.Zoom) < 0 Then
                    hScr.value = 0
                Else
                    hScr.value = hScr.value - Speed * (TileW * magnifier.Zoom)
                End If
    End If
            
    If x > picpreview.Width Then
                'move the map X tile to the right
                If hScr.value + Speed * (TileW * magnifier.Zoom) > hScr.Max Then
                    hScr.value = hScr.Max
                Else
                    hScr.value = hScr.value + Speed * (TileW * magnifier.Zoom)
                End If
    End If
    
    If y < 0 Then
                'move the map X tile up
                If vscr.value - Speed * (TileH * magnifier.Zoom) < 0 Then
                    vscr.value = 0
                Else
                    vscr.value = vscr.value - Speed * (TileH * magnifier.Zoom)
                End If
    End If
    
    If y > picpreview.Height Then
                'move the map X tile down
                If vscr.value + Speed * (TileH * magnifier.Zoom) > vscr.Max Then
                    vscr.value = vscr.Max
                Else
                    vscr.value = vscr.value + Speed * (TileH * magnifier.Zoom)
                End If
    End If
End Sub
